%define python_sitelib %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")
%define python_sitearch %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")
%global momorel 1
%global pyver 2.5

Summary: User space tools for 2.6 kernel auditing
Name: audit
Version: 1.5.4
Release: %{momorel}m%{?dist}
License: GPL
Group: System Environment/Daemons
URL: http://people.redhat.com/sgrubb/audit/
Source0: http://people.redhat.com/sgrubb/audit/%{name}-%{version}.tar.gz
NoSource: 0

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: libtool swig python-devel pkgconfig
# BuildRequires: kernel-headers >= 2.6.18
BuildRequires: automake >= 1.9
BuildRequires: autoconf >= 2.59
BuildRequires: python-devel >= %{pyver}
Requires: %{name}-libs = %{version}-%{release}
Requires: chkconfig
Obsoletes: audit-audispd-plugins

%description
The audit package contains the user space utilities for
storing and searching the audit records generate by
the audit subsystem in the Linux 2.6 kernel.

%package libs
Summary: Dynamic library for libaudit
License: LGPL
Group: Development/Libraries

%description libs
The audit-libs package contains the dynamic libraries needed for 
applications to use the audit framework.

%package libs-devel
Summary: Header files and static library for libaudit
License: LGPL
Group: Development/Libraries
Requires: %{name}-libs = %{version}-%{release}
# Requires: kernel-headers >= 2.6.18

%description libs-devel
The audit-libs-devel package contains the static libraries and header 
files needed for developing applications that need to use the audit 
framework libraries.

%package libs-python
Summary: Python bindings for libaudit
License: LGPL
Group: Development/Libraries
Requires: %{name}-libs = %{version}-%{release}
Requires: kernel-headers >= 2.6.17

%description libs-python
The audit-libs-python package contains the bindings so that libaudit
and libauparse can be used by python.

# %%package audispd-plugins
# Summary: Default plugins for the audit dispatcher
# License: LGPL
# Group: System Environment/Daemons

# %%description audispd-plugins
# The audispd-plugins package contains plugins for the audit dispatcher.

%prep
%setup -q

find . -type f | xargs perl -pi -e "s,rc.d/,,"

%build
autoreconf -fv --install
export CFLAGS="$RPM_OPT_FLAGS"
%configure --sbindir=/sbin --libdir=/%{_lib}
%make

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/{sbin,etc/{sysconfig,audispd/plugins.d,rc.d/init.d}}
mkdir -p %{buildroot}/%{_mandir}/man8
mkdir -p %{buildroot}/%{_lib}
mkdir -p %{buildroot}/usr/{lib,lib32}/audit
mkdir -p %{buildroot}/%{_var}/log/audit
make DESTDIR=%{buildroot} transform='s,x,x,' install

mkdir -p %{buildroot}/%{_libdir}
# This winds up in the wrong place when libtool is involved
mv %{buildroot}/%{_lib}/libaudit.a %{buildroot}%{_libdir}
# mv %{buildroot}/%{_lib}/libauparse.a %{buildroot}%{_libdir}
curdir=`pwd`
cd %{buildroot}/%{_libdir}
LIBNAME=`basename \`ls %{buildroot}/%{_lib}/libaudit.so.*.*.*\``
ln -s ../../%{_lib}/$LIBNAME libaudit.so
# LIBNAME=`basename \`ls %{buildroot}/%{_lib}/libauparse.so.*.*.*\``
# ln -s ../../%{_lib}/$LIBNAME libauparse.so
cd $curdir
# Remove these items so they don't get picked up.
rm -f %{buildroot}/%{_lib}/libaudit.so
rm -f %{buildroot}/%{_lib}/libauparse.so
rm -f %{buildroot}/%{_lib}/libaudit.la
rm -f %{buildroot}/%{_lib}/libauparse.la
rm -f %{buildroot}/%{_libdir}/python*/site-packages/_audit.a
rm -f %{buildroot}/%{_libdir}/python*/site-packages/_audit.la
rm -f %{buildroot}/%{_libdir}/python*/site-packages/_auparse.a
rm -f %{buildroot}/%{_libdir}/python*/site-packages/_auparse.la
rm -f %{buildroot}/%{_libdir}/python*/site-packages/*.pyo
rm -f %{buildroot}/%{_libdir}/python*/site-packages/*.pyc

# On platforms with 32 & 64 bit libs, we need to coordinate the timestamp
touch -r ./audit.spec $RPM_BUILD_ROOT/etc/libaudit.conf

%clean
rm -rf %{buildroot}

%post libs -p /sbin/ldconfig

%post
/sbin/chkconfig --add auditd
if [ -f /etc/auditd.conf ]; then
   mv /etc/auditd.conf /etc/audit/auditd.conf
fi
if [ -f /etc/audit.rules ]; then
   mv /etc/audit.rules /etc/audit/audit.rules
fi
if [ -f /etc/audit/auditd.conf ]; then
   tmp=`mktemp /etc/audit/auditd-post.XXXXXX`
   if [ -n $tmp ]; then
      sed 's|^#dispatcher|dispatcher|g' /etc/audit/auditd.conf > $tmp && \
      cat $tmp > /etc/audit/auditd.conf
      rm -f $tmp
   fi
fi

%preun
if [ $1 -eq 0 ]; then
   /sbin/service auditd stop > /dev/null 2>&1
   /sbin/chkconfig --del auditd
fi

%postun libs
/sbin/ldconfig 2>/dev/null

%postun
if [ $1 -ge 1 ]; then
   /sbin/service auditd condrestart > /dev/null 2>&1 || :
fi

%files libs
%defattr(-,root,root)
%attr(755,root,root) /%{_lib}/libaudit.*
%attr(755,root,root) /%{_lib}/libauparse.*
%config(noreplace) %attr(640,root,root) /etc/libaudit.conf

%files libs-devel
%defattr(-,root,root)
%{_libdir}/libaudit.a
#%{_libdir}/libauparse.a
%{_libdir}/libaudit.so
#%{_libdir}/libauparse.so
%{_includedir}/libaudit.h
%{_includedir}/auparse.h
%{_includedir}/auparse-defs.h
%{_mandir}/man3/*

%files libs-python
%defattr(-,root,root)
%attr(750,root,root) /sbin/audispd
%{python_sitearch}/_audit.so
%{python_sitearch}/auparse.so
%{python_sitelib}/audit.py

%files
%defattr(-,root,root,-)
%doc  README COPYING ChangeLog sample.rules contrib/capp.rules contrib/lspp.rules contrib/skeleton.c init.d/auditd.cron
%attr(0644,root,root) %{_mandir}/man8/*
%attr(0644,root,root) %{_mandir}/man5/*
%attr(750,root,root) /sbin/auditctl
%attr(750,root,root) /sbin/auditd
%attr(755,root,root) /sbin/ausearch
%attr(755,root,root) /sbin/aureport
%attr(750,root,root) /sbin/autrace
%attr(755,root,root) /etc/init.d/auditd
%attr(750,root,root) %{_var}/log/audit
%attr(750,root,root) %dir /etc/audit
%attr(750,root,root) %dir /etc/audispd
%attr(750,root,root) %dir /etc/audispd/plugins.d
%attr(750,root,root) %dir /usr/lib/audit
%config(noreplace) %attr(640,root,root) /etc/audit/auditd.conf
%config(noreplace) %attr(640,root,root) /etc/audit/audit.rules
%config(noreplace) %attr(640,root,root) /etc/sysconfig/auditd

%changelog
* Thu Jul  5 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.5.4-1m)
- update to 1.5.4

* Sun Jun  3 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.5.3-1m)
- update to 1.5.3
- NoSource and adjust %%files section

* Mon May  7 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.5.2-2m)
- add Obsoletes: audit-audispd-plugins, it has no %%files

* Wed May  2 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.5.2-1m)
- update 1.5.2

* Sun Mar 11 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (1.5-3m)
- add python libdir macro and modify python libdir

* Sat Mar 10 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (1.5-2m)
- modify libdir

* Thu Mar  8 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.5-1m)
- update 1.5
- create audit-audispd-plugins package

* Mon Feb 26 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (1.4.1-2m)
- modify pydir

* Tue Feb 20 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.4.1-1m)
- update 1.4.1 

* Thu Feb 15 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.4-2m)
- remove Requires: kernel-headers for the moment

* Thu Feb 15 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.4-1m)
- update 1.4 

* Tue Feb  6 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.2.5-4m)
- delete pyc pyo

* Sun Dec 24 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (1.2.5-3m)
- fix python modue install path

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (1.2.5-2m)
- rebuild against python-2.5

* Sat Jul 29 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.2.5-1m)
- version up

* Fri May 12 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.5-1m)
- version up

* Wed May 10 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.3-2m)
- rebuild against swig

* Sun Feb 12 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.3-1m)
- import from fc-devel

* Thu Jan 5 2006 Steve Grubb <sgrubb@redhat.com> 1.1.3-1
- Add timestamp to daemon_config messages (#174865)
- Add error checking of year for aureport & ausearh
- Treat af_unix sockets as files for searching and reporting
- Update capp & lspp rules to combine syscalls for higher performance
- Adjusted the chkconfig line for auditd to start a little earlier
- Added skeleton program to docs for people to write their own dispatcher with
- Apply patch from Ulrich Drepper that optimizes resource utilization
- Change ausearch and aureport to unlocked IO

* Thu Dec 5 2005 Steve Grubb <sgrubb@redhat.com> 1.1.2-1
- Add more message types

* Wed Nov 30 2005 Steve Grubb <sgrubb@redhat.com> 1.1.1-1
- Add support for alpha processors
- Update the audisp code
- Add locale code in ausearch and aureport
- Add new rule operator patch
- Add exclude filter patch
- Cleanup make files
- Add python bindings

* Wed Nov 9 2005 Steve Grubb <sgrubb@redhat.com> 1.1-1
- Add initial version of audisp. Just a placeholder at this point
- Remove -t from auditctl

* Mon Nov 7 2005 Steve Grubb <sgrubb@redhat.com> 1.0.12-1
- Add 2 more summary reports
- Add 2 more message types

